Add efidev.4 and efirt.9 manual pages from FreeBSD.
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 5.4 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 FFS_ROOT OPTION REMOVED
16 -----------------------
17
18 The FFS_ROOT kernel configuration option has been finally removed, after
19 having been a no-op since 4.9. That means users using a custom kernel
20 configuration file that still contains it need to remove the option from
21 that file.
22
23 +-----------------------------------------------------------------------+
24 +         UPGRADING DRAGONFLY FROM 5.2 TO LATER VERSIONS                +
25 +-----------------------------------------------------------------------+
26
27 DIGI, RP AND SI DRIVERS REMOVED
28 -------------------------------
29
30 The digi(4), rp(4) and si(4) serial drivers have been removed. None of
31 them were in our default kernel configuration file. The sicontrol(8)
32 utility was removed, too.
33
34 MKINITRD COMMAND REMOVED
35 ------------------------
36
37 The mkinitrd(8) command is removed and its functionality is replaced by
38 the new "initrd" make target.  After rebooting into the new world and
39 verifying everything works, execute "make initrd" to upgrade the rescue
40 tools and initrd image.
41
42 IPSEC, IPSEC_ESP AND IPSEC_DEBUG REMOVED FROM VKERNEL64 CONFIG
43 --------------------------------------------------------------
44
45 IPsec has been removed from the system. Of our standard kernel
46 configurations, only the virtual kernel one had it. People running
47 vkernels with configuration files derived from our VKERNEL64 will
48 have to remove these options manually.
49
50 +-----------------------------------------------------------------------+
51 +         UPGRADING DRAGONFLY FROM 5.0 TO LATER VERSIONS                +
52 +-----------------------------------------------------------------------+
53
54 VIRTIO_PCI REMOVED FROM KERNEL CONFIG
55 -------------------------------------
56
57 The "device virtio_pci" line in X86_64_GENERIC has been removed. People
58 with configuration files derived from it have to remove it manually.
59
60 VARIOUS 'R' COMMANDS AND DAEMONS REMOVED
61 ----------------------------------------
62
63 rcp(1), rlogin(1), rlogind(8), rsh(1) and rshd(8) have been removed.
64 For those that still need them, there is the net/bsdrcmds port.
65
66 VARIOUS FORMER OPTIONS REMOVED
67 ------------------------------
68
69 Various former kernel configuration options which had been no-ops for
70 some time were completely removed: SYSVMSG, SYSVSEM, SYSVSHM, P1003_1B,
71 _KPOSIX_VERSION and DSCHED_FQ. Users that have any of these still in
72 their kernel configuration files have to remove them.
73
74 BOOTSTRAPPING LIMITED FROM PRE 4.4
75 ----------------------------------
76
77 Upgrading to 5.1 and later versions now require at least 4.4 in
78 preparations for upcoming base compilers updates.
79
80 IF_PPP, PPPD, IF_FAITH, AND FAITHD REMOVED
81 ------------------------------------------
82
83 if_ppp has been replaced by "user ppp", i.e. ppp(8) and tun(4). It had
84 already been removed from our default kernel configuration before 5.0,
85 so only people with custom configurations based on earlier X86_64_GENERIC
86 will have to remove it manually.
87
88 The faith(4) interface has been completely removed after it had also
89 been removed from our default kernel configuration. 
90
91 +-----------------------------------------------------------------------+
92 +         UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS                +
93 +-----------------------------------------------------------------------+
94
95 FFS_ROOT OPTION DISABLED
96 ------------------------
97
98 The FFS_ROOT option has been made a no-op and will be completely removed
99 at some point in the future. Users with a custom kernel configuration
100 can remove this option from it now.
101
102 +-----------------------------------------------------------------------+
103 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
104 +-----------------------------------------------------------------------+
105
106 DSA OPENSSH KEYS DEPRECATED
107 ---------------------------
108
109 Note that DSA OpenSSH keys were deprecated in the 4.6 to 4.8 release. 
110 If you are upgrading from a release older than 4.8 and use DSA OpenSSH 
111 keys, please update your private/public key pair or risk locking 
112 yourself out.
113
114 AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
115 -----------------------------------------------
116
117 They were all in our X86_64_GENERIC kernel configuration file, along with
118 the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
119 configuration files derived from it need adjustment.
120
121 PORTAL FILE SYSTEM REMOVED
122 --------------------------
123
124 It has been broken for a long time now.
125
126 BINUTILS 2.27 REPLACES 2.24, PRIMARY
127 ------------------------------------
128
129 The oldest of the two versions of Binutils, version 2.24, was removed
130 and replaced with Binutils 2.27.  It becomes the primary version version
131 of binutils and version 2.25 becomes the alternate.
132
133 The accepted values of BINUTILSVER are now "binutils227" (default) and
134 "binutils225".  The building of Binutils 2.25 can be prevented by setting
135 NO_ALTBINUTILS=yes in make.conf.
136
137 COMPAT_43 KERNEL OPTION REMOVED
138 -------------------------------
139
140 It was commented out in our default configs for several years now, but
141 might still be present in custom configs created before Nov. 2011.
142
143 OPENSSL REMOVED
144 ---------------
145
146 OpenSSL has been removed from base and replaced with a private version of
147 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
148 pages will remain on the system unless the "make upgrade" command is
149 specifically instructed to remove them.  To do this, define
150 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
151 "make upgrade REMOVE_OPENSSL_FILES=yes"
152
153 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
154 stale OpenSSL files be removed to avoid configuration scripts from using
155 the stale and potentially vulnerable version, but all binaries that are
156 dynamically linked to the OpenSSL libraries should be rebuilt first to
157 avoid breakage.
158
159 OPENSSH HPN REMOVED
160 -------------------
161
162 It has become too cumbersome to maintain HPN patches in OpenSSH in base.
163 To use OpenSSH in base remove HPN config, if you have added it.
164 Check files below for HPN config, see a few lines below.
165   /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
166 sshd(8) will fail to start if HPN config is used.
167
168 NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
169
170 HPN config:
171 HPNDisabled
172 HPNBufferSize
173 TcpRcvBuf
174 TcpRcvBufPoll
175 NoneEnabled
176 NoneSwitch
177 cipher MTR-AES-CTR
178 cipher NONE
179
180 OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
181 circumstances, especially for networking.
182 If HPN functionality is needed, install security/openssh from dports.
183
184 CS, EX AND VX DRIVERS REMOVED
185 -----------------------------
186
187 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
188 old and its doubtful they ever worked properly in x86_64 but they were
189 in X86_64_GENERIC, so custom configurations derived from it have to be
190 adjusted.
191
192 +-----------------------------------------------------------------------+
193 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
194 +-----------------------------------------------------------------------+
195
196 AMD REMOVED
197 -----------
198
199 The am-utils automounter suite has been removed. It stopped working
200 at some point and was never fixed. autofs(5) and the associated
201 userland has been brought in from FreeBSD and replaces it.
202
203 AN DRIVER REMOVED
204 -----------------
205
206 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
207 config file, so any configurations derived from it have to be adjusted.
208
209 /DEV/DRI GROUP CHANGED
210 ----------------------
211
212 The default group assigned to /dev/dri entries has been changed
213 from 'wheel' to 'video' with the id of '44'. If you want to have
214 access to the dri devices please add yourself to the video group
215 with:
216
217 # pw groupmod video -m $USER
218
219 +-----------------------------------------------------------------------+
220 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
221 +-----------------------------------------------------------------------+
222
223 DSCHED REMOVED
224 --------------
225
226 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
227 in our default kernel config file. So the DSCHED_FQ option has been turned
228 into a no-op for now and can be removed from custom configurations.
229
230 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
231 -------------------------------------------------
232
233 The est(4) driver has been removed. All CPUs it supported (except one)
234 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
235 report back if there are any issues with this CPU and our regular ACPI
236 P-state support.
237
238 Also, compile_et(1) and com_err(3) have been removed as well. They
239 should have been removed along with kerberos support, back in 2009.
240
241 SEVERAL LOCALES RENAMED
242 -----------------------
243
244 Several locales were using obsolete and misleading names, and thus have
245 been adjusted to current standards. Any users of the following locales
246 need to select alternates:
247
248 DFLY 4.2 locale            DFLY 4.4 alterative locale
249 ---------------            ------------------------------------
250 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
251 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
252 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
253 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
254 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
255 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
256 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
257 zh_CN.GBK                  zh_Hans_CN.GBK
258 zh_CN.UTF-8                zh_Hans_CN.UTF-8
259 zh_CN.eucCN                zh_Hans_CN.eucCN
260 zh_CN.GB2312               zh_Hans_CH.GB2312
261 zh_CN.GB18030              zh_Hans_CH.GB18030
262 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
263 zh_HK.UTF_8                zh_Hant_HK.UTF-8
264 zh_TW.Big5                 zh_Hant_TW.Big5
265 zh_TW.UTF-8                zh_Hant_TW.UTF-8
266
267 +-----------------------------------------------------------------------+
268 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
269 +-----------------------------------------------------------------------+
270
271 BINUTILS 2.25 REPLACES 2.22, PRIMARY
272 ------------------------------------
273
274 The oldest of the two versions of Binutils, version 2.22, was removed
275 and replaced with Binutils 2.25.  It becomes the primary version version
276 of binutils and version 2.24 becomes the alternate.  There are 8 current
277 CVE written against 2.24, so for security reasons version 2.25 should
278 always be used.
279
280 The accepted values of BINUTILSVER are now "binutils225" (default) and
281 "binutils224".  The building of Binutils 2.24 can be prevented by setting
282 NO_ALTBINUTILS=yes in make.conf.
283
284 LOADER OPTIONS CHANGED
285 ----------------------
286
287 Right after the development branch started, the Fred art accompanying the
288 loader menu was improved.  The line between Fred and the menu was removed
289 by default (but can optionally be returned) and the placement shifted as
290 a result.  The drawing was improved, and the colored version was improved,
291 changing the eyes and wing color from white to red.  A new color version
292 of Fred was added, one with a blue scheme.
293
294 The loader menu defaults have changed since release 4.0:  The vertical
295 line was removed, the loader is displayed in color by default*, and the
296 blue scheme is used.
297
298 The loader.conf changes are:
299 loader_color:   option has been removed
300 loader_plain:   option has been added, it changed menu to monochrome
301 fred_is_red:    changes color scheme from blue to red
302 fred_is_blue:   option existed only on 4.1, it has been removed
303 fred_separated: Adds line between Fred and menu (as seen previously)
304
305 * If loader.conf defines "console" as "comconsole" or "console" is defined
306   in the environment as "comconsole" then color will not be displayed,
307   even if loader_plain value is "NO".
308
309 SENDMAIL REMOVED FROM BASE
310 --------------------------
311
312 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
313 If the system being upgraded is still configured to use the sendmail
314 binaries from base, the "make upgrade" command will fail.
315
316 The administrator must change /etc/mail/mailer.conf to switch the
317 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
318 command that permanently removes sendmail executables and could
319 potentially break a running mail server.
320
321 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
322 detailed instructions on how to configure the MTA selection.
323
324 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
325 --------------------------------------------
326
327 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
328 no-ops. They can be removed from custom kernel configurations.
329
330 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
331 --------------------------------------------
332
333 Many more sound devices may be detected.
334
335 If the default device choosen isn't to your liking, setting the sysctl
336 hw.snd.default_unit to a different number will change it.
337
338 SCTP SUPPORT DROPPED
339 --------------------
340
341 Support for the SCTP protocol has been removed.
342
343 OLD USB DRIVERS REMOVED
344 -----------------------
345
346 The old USB stack, along with the kernel config option "device oldusb"
347 and the make.conf variable "WANT_OLDUSB" have been removed. This means
348 that for custom kernel configuration files which were derived from a
349 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
350 various (old USB stack specific) devices will now complain about being
351 unknown:
352
353   * oldusb      (obviously)
354   * natausb     (not yet ported to usb4bsd)
355   * rue         (not yet ported to usb4bsd)
356   * ugen        (no longer needed in usb4bsd)
357   * urio        (not yet ported to usb4bsd)
358   * uscanner    (no longer needed in usb4bsd)
359
360 They should be removed or commented out in such custom kernel configs.
361
362 GCC 5
363 -----
364
365 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
366 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
367 NO_CXX.  The latter was never documented and the latest versions of GCC are
368 partially written in C++ so a C++ compiler is no longer optional.  In
369 practical terms it has not been optional for many years as other base
370 components are also written in C++.  The resource savings by avoiding
371 building Objective-C compiler is so small, the complexity added by NO_OBJC
372 internally was deemed a bad tradeoff so that is the reason for its removal.
373 Also note that no "info" pages are installed with GCC 5.  After this entry
374 was originally written, all info pages were removed from DragonFly.
375
376 GCC 5.1 has been designated as the primary compiler.  As such, there is a
377 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
378 the designated secondary compiler, GCC 4.7.  However, while DPorts
379 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
380 if building ports from source is desired, don't block building of the
381 secondary compiler.
382
383 +-----------------------------------------------------------------------+
384 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
385 +-----------------------------------------------------------------------+
386
387 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
388 -------------------------------------------
389
390 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
391 the default now (even on single-core systems), both for, like, 21 months.
392 We kept the options around as no-ops as a convenience, to allow people
393 using the same config for the then current release and the then current
394 master. That period is now over, so any configs still having those
395 options have to be adjusted.
396
397 SYSVIPC SYSCALLS MADE NON-OPTIONAL
398 ----------------------------------
399
400 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
401 now compiled in by default. The options are no-ops for now.
402
403 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
404 --------------------------------------------------------------------
405
406 The default driver for those controllers is now mrsas(4) due to reports
407 of file system corruption using the mfi(4) driver. The whole issue (and
408 how to deal with potential problems when switching) was explained here:
409
410 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
411
412 A tunable is provided for letting those controllers still attach via
413 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
414
415 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
416 ----------------------------------------
417
418 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
419 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
420 removed in kernel configs derived from X86_64_GENERIC.
421
422 +-----------------------------------------------------------------------+
423 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
424 +-----------------------------------------------------------------------+
425
426 UPDATE FROM MOST RECENT 3.6
427 ---------------------------
428
429 Versions of 3.6 built before June 25th have a bug where installworld might 
430 crash during installation of the new initrd.  Upgrade to the latest version
431 of 3.6 before updating to 3.8 or later.
432
433 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
434 --------------------------------------
435
436 Support for the IPX and NCP network protocols and for mouting NetWare
437 file systems has been dropped. Dito for ATM protocol support.
438
439 INITRD IMAGES NOW INSTALLED BY DEFAULT
440 --------------------------------------
441
442 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
443
444 Older images installed under the file name of initrd.img will be removed
445 automatically by the make upgrade process.
446
447 USB4BSD IS NOW THE DEFAULT USB STACK
448 ------------------------------------
449
450 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
451 replace "device usb" with "device oldusb" in the kernel configuration.
452
453 MORE ISA SUPPORT DROPPED
454 ------------------------
455
456 ISA support has been dropped from the following drivers: adv(4), an(4),
457 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
458 si(4), sn(4), and stg(4).
459
460 +-----------------------------------------------------------------------+
461 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
462 +-----------------------------------------------------------------------+
463
464 ABI CHANGE
465 ----------
466
467 Installed third-party software (dports) will have to be rebuilt after upgrade,
468 or reinstalled from binary packages.
469
470 UPDATING FROM 3.4 TO 3.6
471 ------------------------
472
473 This only applies for this specific upgrade due to locale changes; it is 
474 not needed for upgrades after 3.6.  Please update in this order:
475
476 make buildworld
477 make buildkernel
478 make installworld
479 make installkernel
480 *reboot*
481 make upgrade
482
483 See this mailing list post for details:
484 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
485
486 CYRIX OPTIONS REMOVED
487 ---------------------
488
489 The following Cyrix related options have been removed: CPU_BTB_EN,
490 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
491 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
492 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
493
494 ISA SUPPORT REMOVED FROM RP(4)
495 ------------------------------
496
497 ISA support has been removed from the rp(4) driver. It is now PCI only.
498
499 +-----------------------------------------------------------------------+
500 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
501 +-----------------------------------------------------------------------+
502
503 COMPAT_SUNOS OPTION REMOVED
504 ---------------------------
505
506 The COMPAT_SUNOS option has been removed. It was meant to provide binary
507 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
508
509 ISA SOUND CARD SUPPORT REMOVED
510 ------------------------------
511
512 The following modules have been removed (all for ISA sound cards):
513 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
514
515 GCC 4.7
516 -------
517
518 DragonFly has switched base compilers.  GCC 4.7 is now the default
519 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
520 variable ceases to work now.
521
522 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
523 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
524 highly discouraged.  There are a few packages in pkgsrc that do not build
525 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
526 this time, it is recommended to keep both compilers on the base system.
527
528 SMP OPTION REMOVED
529 ------------------
530
531 The SMP kernel option has been made a no-op. All kernels now feature SMP
532 support. If you have 'options SMP' in your kernel config, you can as well
533 remove it.
534
535 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
536 ---------------------------------------------------------------------------
537
538 The DEVICE_POLLING kernel option has been made a no-op and it has been
539 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
540 kernel config, you need to change it to IFPOLL_ENABLE.
541
542 Also, the KTR_POLLING kernel option has been removed, so it must be
543 removed from kernel configs that have it.
544
545 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
546 ---------------------------------------------------
547
548 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
549 cards will no longer be detected.
550
551 The same has been done for Stallion multiport serial controllers. stli(4)
552 has been completely removed (along with the stlload(8) and stlstty(8)
553 utilities) and stl(4) was changed to support only PCI cards. Similarly,
554 ISA support was removed from cy(4) too. All these drivers are i386 only.
555
556 COMPAT_OLDISA OPTION GONE
557 -------------------------
558
559 The i386 specific COMPAT_OLDISA kernel option has been removed, since
560 nothing needs it anymore.
561
562 +-----------------------------------------------------------------------+
563 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
564 +-----------------------------------------------------------------------+
565
566 APIC_IO OPTION REMOVED
567 ----------------------
568
569 The APIC_IO kernel option is no longer accepted after having been without
570 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
571 If you have 'options APIC_IO' in your kernel config, you'll have to
572 remove it.
573
574 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
575 -----------------------------------------
576
577 The wdog framework is now compiled into our kernels by default, so the
578 options are no longer needed.
579
580 DOSCMD(1) REMOVED
581 -----------------
582
583 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
584 NO_X make.conf option was removed too.
585
586 GCC 4.7
587 -------
588
589 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
590 default compiler in base (default is still GCC 4.4).
591
592 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
593 NO_GCC47 in /etc/make.conf.
594
595 USB4BSD
596 -------
597
598 A new USB stack (from FreeBSD) has been brought in. The following
599 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
600 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
601 and uaudio.
602
603 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
604 be put in make.conf and device "usb4bsd" (quotes needed) has to
605 replace device usb in the kernel config. After that, a full
606 build/install/upgrade cycle is needed.
607
608 Note that this is experimental and incomplete, but we are interested
609 in hearing about issues with it, of course.
610
611 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
612 ---------------------------------------------
613
614 ISA adapter support was dropped from the aic(4) driver.
615
616 +-----------------------------------------------------------------------+
617 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
618 +-----------------------------------------------------------------------+
619
620 SEVERAL ISA DRIVERS REMOVED
621 ---------------------------
622
623 The following ISA only drivers have been removed along with a couple of
624 associated userland tools:
625
626 aha(4)
627 asc(4) & sasc(1)
628 ctx
629 dgb(4)
630 el(4)
631 gpib
632 gsc(4) & sgsc(1)
633 ie(4)
634 labpc(4)
635 le(4)
636 mse(4)
637 rc(4)
638 rdp(4)
639 spigot
640 tw(4) & xten(1) & xtend(8)
641 wl(4) & wlconfig(8)
642 wt(4)
643
644 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
645 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
646 file.
647
648 If buildkernel complains about any of these drivers, just remove them
649 from your kernel configuration.
650
651 BINUTILS 2.20
652 -------------
653 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
654 values of BINUTILSVERS are now binutils221 and binutils222 (default).
655
656 BUILDWORLD/-KERNEL PARALLELIZATION WORK
657 ---------------------------------------
658 Due to changes in the way we build with more than one make job, you
659 will have to update install(1) and mkdir(1) prior to buildworld if you
660 want to build with 'make -j':
661
662 cd /usr/src/usr.bin/xinstall; make; make install; make clean
663 cd /usr/src/bin/mkdir; make; make install; make clean
664
665 DMA(8) UPGRADE
666 --------------
667 dma(8) has been upgraded to v0.7 which no longer supports the
668 /etc/dma/virtusertable. Some of its functionality has been replaced
669 with the MASQUERADE keyword and the EMAIL environment variable (see
670 the dma(8) manual page).
671
672 +-----------------------------------------------------------------------+
673 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
674 +-----------------------------------------------------------------------+
675
676 GCC 4.4 & BINUTILS 2.21
677 -----------------------
678
679 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
680 been made DragonFly's default Binutils.
681
682 That means that any settings that set CCVER to 'gcc44' are not needed
683 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
684 GCC 4.1.
685
686 It also means that 'binutils221' as a value for BINUTILSVER has no
687 effect anymore. 2.17 has been removed and 'binutils220' is available
688 as an option.
689
690 The NO_GCC44 option has been removed and will not affect the build
691 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
692 building in a similar fashion.
693
694 Note that you must do a full buildworld/buildkernel for upgrading.
695
696 pkg_radd settings
697 -----------------
698
699 The config file for pkg_radd has moved from /etc/settings.conf to 
700 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
701 if this is needed.  This warning only applies if /etc/settings.conf 
702 exists.  pkg_radd will continue to work with defaults.
703
704 +-----------------------------------------------------------------------+
705 +         20100927                                                      +
706 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
707 +-----------------------------------------------------------------------+
708
709 OpenSSL
710 --------
711
712 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
713 This shouldn't break any 3rd-party software, but you'll need to recompile your
714 3rd-party software if you want it to link against the new version of OpenSSL.
715
716 Loader
717 -------
718
719 A new loader (dloader) has been added which better handles booting from
720 multiple kernel/module versions.
721
722 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
723
724         cd /usr/src
725         make buildworld
726         make installworld
727         make upgrade
728         make buildkernel KERNCONF=<KERNELNAME>
729         make installkernel KERNCONF=<KERNELNAME>
730
731 Note that you must installworld and run the 'upgrade' target before
732 installing the new kernel.
733
734 BIND
735 -----
736
737 BIND has been removed from the base system.  The ldns and drill tools have 
738 been added for basic functionality.  Use 'drill' where you would normally 
739 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
740 net/bind95, net/bind96, or net/bind97 as of this writing.
741
742 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
743 include BIND as a pkgsrc package.
744
745 +-----------------------------------------------------------------------+
746 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
747 +                               GENERAL                                 +
748 +-----------------------------------------------------------------------+
749
750 Instructions on how to obtain and maintain DragonFly source code using git
751 are in the development(7) manual page.
752
753 To upgrade a DragonFly system from sources you run the following sequence:
754
755         cd /usr/src
756         make buildworld
757         make buildkernel KERNCONF=<KERNELNAME>
758         make installkernel KERNCONF=<KERNELNAME>
759         make installworld
760
761 You will also want to run the 'upgrade' target to upgrade your /etc and the
762 rest of your system.  The upgrade target is aware of stale files created by
763 older DragonFly installations and should delete them automatically.
764
765         make upgrade
766
767 See the build(7) manual page for further information.
768
769 Once you've done a full build of the world and kernel you can do incremental
770 upgrades of either by using the 'quickworld' and 'quickkernel' targets
771 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
772 the quick targets, try updating your repo first, and then a full buildworld
773 and buildkernel as shown above, before asking for help.
774
775 +-----------------------------------------------------------------------+
776 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
777 +-----------------------------------------------------------------------+
778
779 In 2.1 kernel and modules has moved to boot directory.  For most cases
780 this is handled automatically by 'make upgrade'.  A few cases needs manual
781 intervention:
782
783  * When installing a kernel without first doing a make buildworld,
784    installworld and upgrade to the same DESTDIR as kernel:
785    make DESTDIR/boot directory and move kernel and modules into this boot
786    directory; also move kernel.old and modules.old.
787    Typical example is vkernel(7), use (no modules used):
788
789         cd /var/vkernel
790         mkdir boot
791         chflags noschg kernel
792         mv kernel kernel.old boot
793         chflags schg boot/kernel
794         
795  * When using a boot-only partition, /boot/loader.rc needs to be edited:
796    delete occurrences of '/boot/'.
797    These occurences can normally be deleted in any case, see loader(8).
798
799 +-----------------------------------------------------------------------+
800 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
801 +-----------------------------------------------------------------------+
802
803 In 1.9 major changes to the disk management infrastructure have taken
804 place.  make upgrade may not catch all of your disk devices in /dev,
805 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
806 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
807 and MAKEDEV no longer exists.
808
809 The biggest changes in 1.9 are:
810
811 (1) That whole-slice devices such as da0s1 no longer share the same device
812     id as partition c devices such as da0s1c.
813
814 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
815     with no snooping or reserved sectors.  Consequently you cannot run
816     disklabel on this device.  Instead you must run disklabel on a
817     whole-slice device.
818
819 (3) The 'compatibility' partitions now use slice 0 in the device name,
820     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
821     accessing the disklabel for the compatibility partitions must be
822     done via slice 0 (da0s0).
823
824 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
825     and CCD now run through the disk management layer and are assigned
826     real disk management devices.   VN and CCD in particular do not usually
827     use a MBR and disklabels must be accessed through the compatibility
828     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
829     don't name it 'ccd0s0' in the config file.
830
831 Generally speaking, you have to get used to running fdisk and disklabel on
832 the correctly specified device names.  A lot of the wiggle, such as running
833 disklabel on a partition, has been removed.
834
835 +-----------------------------------------------------------------------+
836 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
837 +-----------------------------------------------------------------------+
838
839 > Kerberos IV
840 -------------
841
842 Kerberos IV (eBones) was removed from the tree, please consider moving to
843 Kerberos 5 (Heimdal).
844
845 > Package Management System
846 ---------------------------
847
848 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
849 management system.  The necessary tools to build and maintain packages
850 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
851 directories are in your PATH variable.
852
853 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
854 the tarball from NetBSD:
855
856         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
857         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
858
859 This tree can then be kept up to date with cvs update:
860
861         cd /usr/pkgsrc; cvs up
862
863 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
864 build and install the pkgsrc bootstrap manually:
865
866         cd /usr/pkgsrc/bootstrap
867         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
868
869 +-----------------------------------------------------------------------+
870 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
871 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
872 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
873 +-----------------------------------------------------------------------+
874
875 The compatibility shims for the build environment have been removed, you
876 have to update to DragonFly 1.2 release branch first.
877
878 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
879 The existing configuration can be converted using /etc/pam.d/convert.sh.
880 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
881 the pam_skey.so module was retired, you have to remove it manually from
882 your configuration, when you convert it.
883
884 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
885 ---------------------
886
887 The following users may be missing from your password file.  Use vipw and
888 add any that are missing:
889
890 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
891 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
892
893 The following groups may be missing from your group file.  Use vi /etc/group
894 and add any that are missing:
895
896 smmsp:*:25:
897 authpf:*:63:
898 _pflogd:*:64:
899
900
901 > Upgrading to DragonFly from FreeBSD
902 ---------------------
903
904 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
905 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
906 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
907 make depend information, it starts from scratch, so no pre-cleaning of the
908 object hierarchy is necessary.
909
910         # get the CVS repository (it is placed in /home/dcvs, 500MB).
911         # Please use the -h option and a mirror site to pull the 
912         # initial repository, but feel free to use the main repository
913         # machine to pull updates.
914         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
915         # install the source from the CVS hierarchy (remove preexisting
916         # FreeBSD src first) (500MB)
917         cd /usr
918         rm -rf src
919         cvs -R -d /home/dcvs checkout -P src
920
921         # build it (500MB used in /usr/obj)
922         #
923         cd /usr/src
924         make buildworld
925         make buildkernel KERNCONF=<KERNELNAME>
926
927 Once you have built DragonFly you have to install it over FreeBSD.  Since
928 DragonFly does not track changes made by FreeBSD to its include file 
929 hierarchy and include file pollution can cause all sorts of unexpected
930 compilation issues to come up, it is best to wipe your include hierarchy
931 prior to installing DragonFly.  Note that you should not wipe any installed
932 FreeBSD header files or binaries until after you have successfully completed
933 the build steps above.
934
935         rm -rf /usr/include
936         mkdir /usr/include
937         make installkernel KERNCONF=<KERNELNAME>
938         make installworld
939
940 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
941 will unconditionally upgrade the /etc files that sysops do not usually
942 mess around with, such as the files in /etc/rc.d.  It will also remove any
943 obsolete files such as utilities and manpages that have been removed from
944 the system since the version you're coming from.  If you are unsure we 
945 recommend that you make a backup of at least your /etc before applying
946 this step.  Note that DragonFly's RC system is basically RCNG from
947 FreeBSD-5, but there are some differences in the contents of the RC files.
948
949         make upgrade
950
951 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
952 Doing so might leave your system in an unusable state.
953
954 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
955 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
956 report these files to the DragonFly developers so that they can be added to
957 the 'upgrade' target.
958